// X̒l@ϕvZ̏lMNɂăI[o[t[𔭐̂
// RpCݒɃI[o[t[`bNK{łB
// X̒l傫Ȃƌ덷傫Ȃ܂ Z̗Ls
unit Main;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, VclTee.TeeGDIPlus,
  VCLTee.TeEngine, VCLTee.Series, Vcl.ExtCtrls, VCLTee.TeeProcs, VCLTee.Chart,
  system.UITypes;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Chart1: TChart;
    Series1: TLineSeries;
    LabeledEdit2: TLabeledEdit;
    Series2: TPointSeries;
    LabeledEdit1: TLabeledEdit;
    Memo1: TMemo;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    Button2: TButton;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Private 錾 }
    procedure Besselgraph(v, Xmax: extended; flag: boolean);
    function BesselG(X: extended; v: extended; flag: boolean): extended;
    function Jvx(v, x: extended; flag: boolean): extended;
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

uses math;

var

// 덷vZpf[^[
  j0x: array[0..10] of extended = ( 1,
                                  0.8414709848078965066525,
                                  0.454648713412840847698,
                                  0.04704000268662240736691,
                                 -0.1892006238269820628432,
                                 -0.1917848549326276937786,
                                 -0.04656924969982097880193,
                                  0.09385522838839844148529,
                                  0.123669780827922722226,
                                  0.04579094280463961886161,
                                 -0.05440211108893698134047
                                );

  i0x: array[0..10] of extended = ( maxextended,
                                  1.175201193643801456882,
                                  1.813430203923509383834,
                                  3.339291642469967299658,
                                  6.822479299281938112227,
                                 14.8406421155577517954,
                                 33.6188595617132046875,
                                 78.33087475332093176768,
                                186.3098532236937732645,
                                450.1713224536433289461,
                               1101.323287470339337724
                                );

const

//xk[CB(2)AB(4)AB(6)A...AB(20)

  B : array[1..10] of extended = ( 1.0 / 6,           // B(2)
                                  -1.0 / 30,
                                   1.0 / 42,
                                  -1.0 / 30,
                                   5.0 / 66,
                                -691.0 / 2730,
                                   7.0 / 6,
                               -3617.0 / 510,
                               43867.0 / 798,
                             -174611.0 / 330);        //  B(20)

  m: integer = sizeof(B) div sizeof(extended);

//------------------------------------------------------------------------------
// K}֐
function Log_Gamma(x: extended): extended;
var
  i : integer;
  sum : extended;
  xx, v  : extended;
  ln_sqrt_2pi: extended;
begin
  ln_sqrt_2pi := ln(sqrt(2 * pi));                    // = ln(2 * pi) / 2;
  sum := 0;
  v := 1;
	while x < m do begin
    v := v * x;
    x := x + 1;
  end;
  xx := 1 / (x * x);
  for i := m downto  2 do
    sum := (sum + B[i] / (i * 2 * (2 * i - 1))) * xx;
  result := (sum + B[1] / 2) / x
      + ln_sqrt_2pi - ln(v) - x + (x - 0.5) * ln(x);
end;

function Gamma(x: extended): extended;  // K}֐
begin
  if x < 0 then begin
    result := pi / (sin(pi * x) * exp(log_Gamma(1 - x)));
  end
  else begin
    result := exp(Log_Gamma(x));
  end;
end;

//----------------------- new --------------------------------------------------
// X l
// v 
// flag false ʏ true ό`
function TForm1.Jvx(v, x: extended; flag: boolean): extended;
var
  k : integer;
  g, j, bkk: extended;

  function Bk(k : integer): extended;
  var
    kn : integer;
    Bn, Y, Zk: extended;
  begin
    Y := -(x / 2) * (x / 2);
    if flag then Y := -Y;
    Bn := 1;
    for kn := 1 to k do begin
      Zk := Y / (kn * (kn + v));
      Bn := Zk * Bn;
    end;
    result := Bn
  end;

begin
  g := Gamma(1 + v);
  bkk := 0;
  for k := 0 to 100 do  bkk := bkk + Bk(k);
  j := power(x / 2, v) / g * bkk;
  result := j;
end;

//-----------------------------------------------------------------------------

// PxbZ֐ ֐gp
// X l
// v 
// flag false ʏ true ό`
function TForm1.BesselG(X: extended; v: extended;  flag: boolean): extended;
const
  Mn = 50;
var
  M : Integer;
  B, S, n: extended;
begin
  n := round(v);
  if (n = v) and (n < 0) then v := abs(v);
  S := 0;
  for M := 0 to MN do begin
    B := 1 / Gamma(M + 1) / Gamma(M + v + 1);   // B = 1 / ((m + 1)(m + n + 1))
    if not flag then
      S := S + power(-1, M) * B * power(X / 2, 2 * M + v)
    else
      S := S + B * power(X / 2, 2 * M + v)
  end;
  if (not flag) and (abs(n) = v) and (n < 0) then S := S * Power(-1, v);
  result := S;
end;


// P틅xbZ֐ Ot\
// v 
// Xmax Otől
// flag false ʏ true ό`
procedure TForm1.Besselgraph(v, Xmax: extended; flag: boolean);
const
  NMAX = 10000;
var
  Y, X: extended;
  I : integer;
  XMIN: extended;
begin
  XMIN := 0;
  x := 0;
  if v = 0 then Y := 1
           else Y := 0;
  Series1.AddXY(X, Y);
  for I := 1 to NMAX - 1 do begin
    X := XMIN + (XMAX - XMIN) * I / NMAX;
    if checkbox2.Checked = true then Y := sqrt(pi/(2 * X)) * BesselG(X, v + 0.5, flag)
                                else Y := sqrt(pi/(2 * X)) * Jvx(v + 0.5, x, flag);
    Series1.AddXY(X, Y);
  end;
end;

// xbZ֐vZ
procedure TForm1.Button1Click(Sender: TObject);
var
  ch: integer;
  X, Y, v, vs2 : extended;
  Flg: boolean;
begin
  val(LabeledEdit1.Text, v, Ch);
  if ch <> 0 then begin
    MessageDlg('vɊԈႢ܂B', mtInformation,
      [mbOk], 0, mbOk);
    exit;
  end;
  val(LabeledEdit2.Text, X, Ch);
  if ch <> 0 then begin
    MessageDlg('XlɊԈႢ܂B', mtInformation,
      [mbOk], 0, mbOk);
    exit;
  end;
  vs2 := 1 / 2;
  Series1.Clear;
  Series2.Clear;
  chart1.LeftAxis.AutomaticMaximum := False;
  chart1.LeftAxis.AutomaticMinimum := False;
  memo1.Clear;
  Chart1.Title.Text.Clear;
  chart1.LeftAxis.Title.Caption := '';
  if checkbox1.Checked = False then begin
    Flg := False;
    if x = 0 then begin
      if v = 0 then Y := 1
               else Y := 0;
    end
    else begin
      if checkbox2.Checked = true then Y := sqrt(pi/(2 * X)) * BesselG(X, v + vs2, Flg)
                                  else Y := sqrt(pi/(2 * X)) * Jvx(v + vs2, X, Flg);
    end;
    if Chart1.LeftAxis.Maximum <= Y + 2 then begin
      Chart1.LeftAxis.Maximum := Y + 2;
      Chart1.LeftAxis.Minimum := Y - 2;
    end
    else begin
      Chart1.LeftAxis.Minimum := Y - 2;
      Chart1.LeftAxis.Maximum := Y + 2;
    end;
    Series2.AddXY(X, Y);
    Chart1.Title.Text.Append('P틅xbZ֐');
    Besselgraph(v, 10, Flg);
    memo1.Lines.Add('P틅xbZ֐');
    memo1.Lines.Add('jvx = ' + floatTostr(Y));
  end
  else begin
    Flg := True;
    if X = 0 then begin
      if v = 0 then Y := 1
               else Y := 0;
    end
    else begin
      if checkbox2.Checked = true then Y := sqrt(pi/(2 * X)) * BesselG(X, v + vs2, Flg)
                                  else Y := sqrt(pi/(2 * X)) * Jvx(v + vs2, X, Flg);
    end;
    if Chart1.LeftAxis.Maximum <= Y + 2 then begin
      Chart1.LeftAxis.Maximum := Y + 2;
      Chart1.LeftAxis.Minimum := Y - 2;
    end
    else begin
      Chart1.LeftAxis.Minimum := Y - 2;
      Chart1.LeftAxis.Maximum := Y + 2;
    end;
    Series2.AddXY(X, Y);
    Chart1.Title.Text.Append('Pό`xbZ֐');
    Besselgraph(v, 5, Flg);
    memo1.Lines.Add('Pό`xbZ֐');
    memo1.Lines.Add('ivx = ' + floatTostr(Y));
  end;
end;

// vZ덷̊mF
procedure TForm1.Button2Click(Sender: TObject);
var
  flg: boolean;
  i, p, l: integer;
  jk, vs2: extended;
  def : extended;
  defs, re, ex, ads, no : string;
begin
  memo1.Clear;
  Series1.Clear;
  Series2.Clear;
  chart1.LeftAxis.AutomaticMaximum := True;
  chart1.LeftAxis.AutomaticMinimum := True;
  {$IFDEF CPUX64}
  chart1.LeftAxis.Title.Caption := 'xxE14';
  Memo1.Lines.Append('X64 extended');
  {$ELSE}
  chart1.LeftAxis.Title.Caption := 'xxE15';
  Memo1.Lines.Append('X86 extended');
  {$ENDIF}
  flg := False;
  vs2 := 1 / 2;
  if checkbox1.Checked = true then flg := true;
  for i := 0 to 10 do begin
    if i = 0 then begin
      if flg then jk := 0
             else jk := 1;
    end
    else begin
      if checkbox2.Checked = true then jk := sqrt(pi/(2 * i)) * BesselG(i, 0 + vs2, flg)
                                  else jk := sqrt(pi/(2 * i)) * Jvx(0 + vs2, i, flg);
    end;
    if flg and (i = 0) then def := 0
                       else begin
                        if flg then def := abs(i0x[i] - jk)
                               else def := abs(j0x[i] - jk);
                       end;
    {$IFDEF CPUX64}
    Series1.AddXY(i, def * 1E14);
    {$ELSE}
    Series1.AddXY(i, def * 1E15);
    {$ENDIF}
    if def <> 0 then
      defs := floatTostr(def)
    else defs := '      0';

    l := length(defs);
    p := pos('E', defs, 1);
    re := copy(defs, 0, 4);
    ex := copy(defs, p, l - p + 1);
    no := inttostr(i);
    if i < 10 then no := '  ' + no;
    if i mod 2 = 0 then
      ads := no + '  ' + re + ex
    else begin
      ads := ads + '      ' + no + '  ' + re + ex;
      memo1.Lines.Append(ads);
    end;
    if i = 10 then memo1.Lines.Append(ads);
  end;
end;


end.
